# 定时器

`setitimer`和`getitimer`是操作系统为应用程序提供的设置定时器的系统调用。定时器的基本功能是间隔一段时间向进程发送特定信号。`setitimer`设置的定时器理论上可以精确到微秒，且能自动循环定时。定时器的信息由结构体`itimerval`记录：

```C++
struct itimerval {
    struct timeval it_interval; /* next value */
    struct timeval it_value;    /* current value */
};
struct timeval {
    time_t      tv_sec;         /* seconds */
    suseconds_t tv_usec;        /* microseconds */
};
```

`it_value`代表距定时器到期的间隔

`it_interval`代表相邻两次定时的间隔

> The element *it_value* is set to the amount of time remaining on the timer, or zero if the timer is disabled. Similarly, *it_interval* is set to the reset value.
>
> Timers decrement from *it_value* to zero, generate a signal, and reset to *it_interval*. A timer which is set to zero (*it_value* is zero or the timer expires and *it_interval* is zero) stops.

为简单起见，维护了一个按照定时器到期时间升序的链表（由于Rust没有链表，就用Vec代替）`ITIMER_MANAGER`，以实现定时功能。每次发生时钟中断时，检查链表头的定时器是否到期，时间复杂度O(1)；插入时需保证升序，时间复杂度O(n)。